%define	use_utf8_dict	1
%define	pkg		anthy

%if %($(pkg-config emacs); echo $?)
%define	emacs_version	22.1
%define	emacs_lispdir	%{_datadir}/emacs/site-lisp
%define	emacs_startdir	%{_datadir}/emacs/site-lisp/site-start.d
%else
%define	emacs_version	%(pkg-config emacs --modversion)
%define	emacs_lispdir	%(pkg-config emacs --variable sitepkglispdir)
%define	emacs_startdir	%(pkg-config emacs --variable sitestartdir)
%endif

%if %($(pkg-config xemacs); echo $?)
%define	xemacs_version	21.5
%define	xemacs_lispdir	%{_datadir}/xemacs/site-packages
%define	xemacs_startdir	%{_datadir}/emacs/site-packages/site-start.d
%else
%define	xemacs_version	%(pkg-config xemacs --modversion)
%define	xemacs_lispdir	%(pkg-config xemacs --variable sitepkglispdir)
%define	xemacs_startdir	%(pkg-config xemacs --variable sitestartdir)
%endif

Name:		anthy
Version:	9100h
Release:	10.1%{?dist}
# The entire source code is LGPLv2+ and dictionaries is GPLv2.
License:	LGPLv2+ and GPLv2
URL:		http://sourceforge.jp/projects/anthy/
Buildroot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	emacs emacs-el


Source0:	http://osdn.dl.sourceforge.jp/anthy/37536/anthy-%{version}.tar.gz
Source1:	anthy-init.el
Patch0:		anthy-fix-typo-in-dict.patch
Patch1:		anthy-corpus.patch

Summary:	Japanese character set input library
Group:		System Environment/Libraries
Obsoletes:	anthy-libs
Provides:	anthy-libs = %{version}
%description
Anthy provides the library to input Japanese on the applications, such as
X applications and emacs. and the user dictionaries and the users information
which is used for the conversion, is stored into their own home directory.
So Anthy is secure than other conversion server.

%package	devel
Summary:	Header files and library for developing programs which uses Anthy
Group:		Development/Libraries
Requires:	anthy = %{version}-%{release}
Requires:	pkgconfig
%description	devel
The anthy-devel package contains the development files which is needed to build
the programs which uses Anthy.

%package -n	emacs-%{pkg}
Summary:	Compiled elisp files to run Anthy under GNU Emacs
Group:		System Environment/Libraries
Requires:	emacs(bin) >= %{emacs_version}
Requires:	anthy = %{version}-%{release}
Obsoletes:	anthy-el < 9100g-1
Provides:	anthy-el = %{version}-%{release}
BuildArch:	noarch

%description -n	emacs-%{pkg}
This package contains the byte compiled elisp packages to run Anthy with GNU
Emacs.

%package -n	emacs-%{pkg}-el
Summary:	Elisp source files for Anthy under GNU Emacs
Group:		System Environment/Libraries
Requires:	emacs-%{pkg} = %{version}-%{release}
BuildArch:	noarch

%description -n	emacs-%{pkg}-el
This package contains the elisp source files for Anthy under GNU Emacs. You
do not need to install this package to run Anthy. Install the emacs-%{pkg}
package to use Anthy with GNU Emacs.


%prep
%setup -q #-a 2
%patch0 -p1 -b .0-typo
%patch1 -p1 -b .1-corpus

%if	%{use_utf8_dict}
function normalize_extra_dict() {
	sed -e 's/^\([^ 	]*\)t[ 	]*\(#[A-Z0-9\*]*\)[ 	]*\([^ 	]*\)$/\1 \2 \3/g' $1 > $1.norm
}
function dict_conv() {
	iconv -f euc-jp -t utf-8 $1 > $1.utf8
}
function gen_dict_args() {
	if ! test -f $RPM_BUILD_DIR/%{name}-%{version}/mkworddic/dict.args.in-orig; then
		cp -a $RPM_BUILD_DIR/%{name}-%{version}/mkworddic/dict.args.in{,-orig}
	fi
	cat <<_EOF_ >> $RPM_BUILD_DIR/%{name}-%{version}/mkworddic/dict.args.in
# Generated by rpm script
set_input_encoding utf8
read @top_srcdir@/alt-cannadic/gcanna.ctd.utf8
read @top_srcdir@/alt-cannadic/gcannaf.ctd.utf8
read @top_srcdir@/alt-cannadic/gtankan.ctd.utf8
read @top_srcdir@/alt-cannadic/extra/g-jiritu-34.t.norm
read @top_srcdir@/alt-cannadic/extra/gc-fullname-34.t.norm
read @top_srcdir@/alt-cannadic/extra/gt-tankanji_kanji-34.t.norm
read @top_srcdir@/alt-cannadic/extra/gt-tankanji_hikanji-34.t.norm
read @top_srcdir@/alt-cannadic/extra/gf-fuzoku-34.t.norm
read @top_srcdir@/mkworddic/adjust.t.utf8
read @top_srcdir@/mkworddic/compound.t.utf8
read @top_srcdir@/mkworddic/extra.t.utf8
read @top_srcdir@/alt-cannadic/g_fname.t
#
build_reverse_dict
set_dict_encoding utf8
read_uc @top_srcdir@/mkworddic/udict
write anthy.wdic
done
_EOF_
touch -r $RPM_BUILD_DIR/%{name}-%{version}/mkworddic/dict.args.in{-orig,}
}

(
	cd alt-cannadic
	for i in gcanna.ctd gcannaf.ctd gtankan.ctd; do
		dict_conv $i
	done
	cd extra
	for i in g-jiritu-34.t gc-fullname-34.t gf-fuzoku-34.t gt-tankanji_hikanji-34.t gt-tankanji_kanji-34.t; do
		normalize_extra_dict $i
	done
);(
	cd mkworddic
	for i in adjust.t compound.t extra.t udict zipcode.t; do
		dict_conv $i
	done
)
gen_dict_args
%endif


%build
%configure --disable-static
# fix rpath issue
sed -ie 's/^hardcode_libdir_flag_spec.*$'/'hardcode_libdir_flag_spec=" -D__LIBTOOL_IS_A_FOOL__ "/' libtool
LD_LIBRARY_PATH=$RPM_BUILD_DIR/%{name}-%{version}/src-main/.libs:$RPM_BUILD_DIR/%{name}-%{version}/src-worddic/.libs make %{?_smp_mflags}
#LD_LIBRARY_PATH=$RPM_BUILD_DIR/%{name}-%{version}/src-main/.libs:$RPM_BUILD_DIR/%{name}-%{version}/src-worddic/.libs make %{?_smp_mflags} update_params0
#LD_LIBRARY_PATH=$RPM_BUILD_DIR/%{name}-%{version}/src-main/.libs:$RPM_BUILD_DIR/%{name}-%{version}/src-worddic/.libs make %{?_smp_mflags} update_params
#LD_LIBRARY_PATH=$RPM_BUILD_DIR/%{name}-%{version}/src-main/.libs:$RPM_BUILD_DIR/%{name}-%{version}/src-worddic/.libs make %{?_smp_mflags} update_params2
#LD_LIBRARY_PATH=$RPM_BUILD_DIR/%{name}-%{version}/src-main/.libs:$RPM_BUILD_DIR/%{name}-%{version}/src-worddic/.libs make %{?_smp_mflags} update_params2
#LD_LIBRARY_PATH=$RPM_BUILD_DIR/%{name}-%{version}/src-main/.libs:$RPM_BUILD_DIR/%{name}-%{version}/src-worddic/.libs make %{?_smp_mflags} update_params2

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT

# remove unnecessary files
rm -rf $RPM_BUILD_ROOT%{_libdir}/lib*.{la,a}

## for emacs-anthy
%__mkdir_p $RPM_BUILD_ROOT%{emacs_startdir}
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{emacs_startdir}

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr (-, root, root, -)
%doc AUTHORS COPYING ChangeLog DIARY NEWS README
%{_bindir}/*
%{_sysconfdir}/*
%{_libdir}/lib*.so.*
%{_datadir}/anthy/

%files devel
%defattr (-, root, root, -)
%doc doc/DICLIB doc/DICUTIL doc/GLOSSARY doc/GRAMMAR doc/GUIDE.english doc/ILIB doc/LEARNING doc/LIB doc/MISC doc/POS doc/SPLITTER doc/TESTING doc/protocol.txt
%{_includedir}/*
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*.pc

%files -n emacs-%{pkg}
%defattr(-, root, root, -)
%doc doc/ELISP
%{emacs_lispdir}/%{pkg}/*.elc
%{emacs_startdir}/*.el
%dir %{emacs_lispdir}/%{pkg}

%files -n emacs-%{pkg}-el
%defattr(-, root, root, -)
%{emacs_lispdir}/%{pkg}/*.el


%changelog

